/*
NAME: ThunderBrowse Tabs For TB2
AUTH: GameSpotting! Networks
DESC: ThunderBrowse's tabs system for Thunderbird 2. Code donated from the sameplace project.
*/

var TBrowse2Tabs =
{
    _init: function (tabs, deck)
    {
		  this._msgpane = (document.getElementById("ThunderBrowsePopup")) ? document.getElementById('ext-messagepane') : document.getElementById('messagepane');
		  
        var _this = this;

        tabs.addEventListener('DOMNodeInserted', function (event)
        {
            if (event.relatedNode == tabs && event.target.tagName == 'tab')
            {
                var tabsHolder = document.getElementById("hbox-messagesBox");
                tabsHolder.collapsed = false;
            }
        }, false);

        tabs.addEventListener('DOMNodeRemoved', function (event)
        {
            if (event.relatedNode == tabs && event.target.tagName == 'tab')
            {
                var tabsHolder = document.getElementById("hbox-messagesBox");
                tabsHolder.collapsed = (tabs.childNodes.length == 2);
            }
        }, false);
        tabs.addEventListener('click', function (event)
        {
            if (event.target.nodeName == 'tab' && event.button == 1) 
				_this.removeTab(event.target);
        }, false);

        tabs.addEventListener('select', function (event)
        {
		  
				var watch = null;
				
            TBrowserCore.updateSecurityStatus();
            //To Mail Tab
				if (tabs.selectedIndex == 0 || deck.getAttribute("collapsed") == false)
            {
                var currenturi = tbrowser.currentURI.spec;
                if ((currenturi.search(TBrowseGlobal.mailProtocols) == 0) == true) 
						TBrowserCore.toggleContent(false);
					 _this._msgpane.setAttribute("collapsed", false);
                if (document.getElementById("singlemessage")) 
						document.getElementById("singlemessage").setAttribute("collapsed", false);
						
                deck.setAttribute("collapsed", true);					 
                if (thunderbrowseprefs.getBoolPref("hideme") == true && !document.getElementById("ThunderBrowsePopup")) 
						document.getElementById("urlbox").setAttribute("collapsed", true);
                else 
						document.getElementById("urlbox").setAttribute("collapsed", false);
                if (document.getElementById("messagePaneWrapper")) 
						document.getElementById("messagePaneWrapper").parentNode.setAttribute("collapsed", false);
                checkBrowser();
                document.getElementById("urlfield").setAttribute("value", currenturi);
                if (document.getElementById('attachment-splitter')) 
						document.getElementById('attachment-splitter').setAttribute("hidden", false);
            }
            //everything else
				else if (tabs.selectedIndex > 0 || deck.getAttribute("collapsed") == true)
            {
                TBrowsePermissions.imagesAllowed(tabs.selectedItem.browser);
                TBrowserCore.collapseBars(true);
                if (document.getElementById("messagePaneWrapper")) 
						document.getElementById("messagePaneWrapper").parentNode.setAttribute("collapsed", true);
                TBrowserCore.toggleContent(true);
                deck.setAttribute("collapsed",false);
                if (document.getElementById("singlemessage")) 
						document.getElementById("singlemessage").setAttribute("collapsed", true);
                _this._msgpane.setAttribute("collapsed", true);
                document.getElementById("urlbox").setAttribute("collapsed", false);
                if (document.getElementById('attachment-splitter')) 
						document.getElementById('attachment-splitter').setAttribute("hidden", true);
            }
            if (tabs.selectedIndex == 0) 
					tabs.setAttribute('mode', 'totallyrealdude');
            else 
					tabs.removeAttribute('mode');
            deck.selectedIndex = tabs.selectedIndex;
            document.getElementById("urlbar-bck").setAttribute("disabled", true);
            document.getElementById("urlbar-fwd").setAttribute("disabled", true);
            var thetab = tabs.selectedItem;
            var browserfortab = thetab.browser;
            try
            {
                if (browserfortab.currentURI.spec) 
						document.getElementById("urlfield").setAttribute("value", browserfortab.currentURI.spec);
            }
            catch (e)
            {
                document.getElementById("urlfield").setAttribute("value", "");
            }
            if (browserfortab.getAttribute("history-back") != "") 
					document.getElementById("urlbar-bck").setAttribute("disabled", false);
            else 
					document.getElementById("urlbar-bck").setAttribute("disabled", true);
            if (browserfortab.getAttribute("history-forward") != "") 
					document.getElementById("urlbar-fwd").setAttribute("disabled", false);
            else 
					document.getElementById("urlbar-fwd").setAttribute("disabled", true);
				if (browserfortab.currentURI.scheme == "mailbox" && document.getElementById("msgHeaderView"))
                document.getElementById("msgHeaderView").setAttribute("collapsed", false);
            TBrowserCore.toggleLaunch(true);					
            TBHistory.reloadBackMenu();
				TBrowserCore.getWindowTitle();
            TBrowsExtras.checkIfURLsame();
								
				TBrowserCore.getFavicon(thetab);				
        }, false);

        if (document.getAnonymousElementByAttribute(tabs, 'class', 'tabs-closebutton-box'))
        {
            document.getAnonymousElementByAttribute(tabs, 'class', 'tabs-closebutton-box').firstChild.addEventListener('command', function (event)
            {
                _this.removeTab(tabs.selectedItem);
            }, false);
        }
        else
        {
            var closebutton = document.createElement('toolbarbutton');
            closebutton.setAttribute("class", "tbrowse-tab-close-button");
            closebutton.addEventListener('command', function (event)
            {
                _this.removeTab(tabs.selectedItem);
            }, false);
            document.getElementById("hbox-messagesBox").appendChild(closebutton);
        }
        this._tabs = tabs;
        this._deck = deck;
    },
    get selectedTab()
    {
        return document.getElementById('thunderbrowse-tabs').selectedItem;
    },

    set selectedTab(tab)
    {
        document.getElementById('thunderbrowse-tabs').selectedItem = tab;
    },
    tabContainer: function ()
    {
        return document.getElementById("thunderbrowse-tabs");
    },
    _generateIDString: function ()
    { /*oddly, if I give new Date arguments, it returns undefined*/
        var theDate = new Date();
        var idNum = Math.round(Math.random() * (theDate.getMilliseconds() * theDate.getMinutes() * theDate.getHours()));
        var idString = "tbr" + idNum;
        if (document.getElementById(idString)) idNum * theDate.getMinutes();
        return idString;
    },
    addTab: function (url, refer, secret, dataPost, loadinbg)
    {
        checkBrowser();
        if (tbrowser)
        {
            var browser = document.createElement('browser');
            browser.setAttribute("onclick", "return contentAreaClick(event);");
            browser.setAttribute("onmouseup", "return ThunderBrowseHandler.clickEvent(event);");
            browser.setAttribute("onkeydown", "return ThunderBrowseHandler.keyEvent(event);");
            browser.setAttribute("onmousedown", "return ThunderBrowseHandler.watchMouseHolds(event);");
            if (secret != true)
            {
                var thehp = TBrowseDev.getUserHomepage();
                browser.setAttribute("history-back", thehp);
            }
            else 
					browser.setAttribute("history-back", "");
            browser.setAttribute("history-forward", "");
            browser.setAttribute("ondragover", "nsDragAndDrop.dragOver(event,loadurlObserver)");
            browser.setAttribute("ondragdrop", "nsDragAndDrop.drop(event,loadurlObserver)");
            if (document.getElementById('messagePaneContext')) 
					browser.setAttribute("context", "messagePaneContext");
            else 
					browser.setAttribute("context", "mailContext");
            browser.setAttribute("type", "content-primary");
            browser.setAttribute("flex", "1");
            browser.setAttribute("id", ThunderTabBrowser._generateIDString());
            this._deck.appendChild(browser);
            TBrowserHooks.addGBrowserEl(browser);
            TBrowsePermissions.imagesAllowed(browser);

            var tab = document.createElement('tab');
            tab.setAttribute("flex", "1");
            tab.setAttribute("context", "thunderBrowseTabMenu");
            tab.setAttribute("class", "tbrowseTab");
            tab.setAttribute("isLoaded", false);
            tab.setAttribute("ondragover", "nsDragAndDrop.dragOver(event,loadurlObserver)");
            tab.setAttribute("linkedpanel", browser);
            tab.setAttribute("linkedBrowser", browser);
            tab.setAttribute("image", "chrome://global/skin/throbber/Throbber-small.gif");
            tab.setAttribute("ondragdrop", "nsDragAndDrop.drop(event,loadurlObserver)");
            this._tabs.appendChild(tab);

            browser.tab = tab;

            browser.addEventListener('DOMTitleChanged', function (event)
            {
                if (event.target != browser.contentDocument) return;
                if (event.target.title.length > 16)
                {
                    var title = event.target.title;
                    var shortenedTitle = title.substring(0, 15) + "...";
                }
                else var shortenedTitle = event.target.title;
                tab.setAttribute('label', shortenedTitle);
                tab.setAttribute("tooltiptext", event.target.title);
            }, true);

            tab.browser = browser;
            TBrowserHooks.addWatchLoads(browser, tab);
            var bgSetting = thunderbrowseprefs.getBoolPref("tabswitch");
            if (loadinbg && loadinbg == true) 
					var bgtab = !bgSetting;
            if (bgSetting == true || bgtab == true) 
					ThunderTabBrowser.selectedTab = tab;
            if (url == null) 
					var url = TBrowseDev.getUserHomepage();
            var customShortCutCheck = TBrowseCommands.checkForCustom(url);
            if (customShortCutCheck != false || (customShortCutCheck != false && customShortCutCheck == "nw"))
            {
                url = customShortCutCheck;
                if (customShortCutCheck == "nw") 
						url = TBrowseDev.getUserHomepage();
            }
            browser.loadURIWithFlags(url, 0, (typeof refer === 'undefined') ? refer : null, "utf-8", ((dataPost != null) ? ThunderBrowseHandler.handlePostData(dataPost) : null));

            return tab;
        }
    },
    getBrowserAtIndex: function (i)
    {
        return this._deck.childNodes[i];
    },
    getBrowserForTab: function (tab)
    {
        if (tab.id == "mail-tab") 
			 return this._msgpane;
        else
        {
            if (tab == this._tabs.firstChild) 
					return this._deck.firstChild;
            else 
					return tab.browser;
        }
    },
    removeTab: function (tab, noswitch)
    {
        // First tab is really just a placeholder for separate message
        // pane.
        if (tab == this._tabs.firstChild) 
			return;
        if (tab == this._tabs.selectedItem)
        {
            TBrowserHooks.removeWatchLoads(tab.browser, tab);
            if (noswitch != "1")
            {
                if (thunderbrowseprefs.getBoolPref("tabsCloseFX") == true)
                {
                    if (!tab.nextSibling) 
							this._tabs.selectedItem = tab.previousSibling;
                    else 
							this._tabs.selectedItem = tab.nextSibling;
                }
                else 
						this._tabs.selectedItem = tab.previousSibling;
            }
        }
        // Force unload event.
        tab.browser.loadURIWithFlags('about:blank');
        this._deck.removeChild(tab.browser);
        this._tabs.removeChild(tab);
        //just to refresh the window
        this._deck.selectedIndex = this._tabs.selectedIndex;
    },
    removeCurrentTab: function ()
    {
        var currentTab = this.selectedTab;
        this.removeTab(currentTab);
    },
    extBrows: function (url)
    {
        ThunderBrowseHandler.loadInExternalBrowser(url);
    },
    loadHomePage: function ()
    {
        var thehp = TBrowseDev.getUserHomepage();
        this.addTab(thehp, null, true);
    },
    openLinkinTab: function ()
    {
      var linkclicked;
      
      if(gContextMenu && gContextMenu.onLink)
        linkclicked = ('getLinkURL' in gContextMenu) ? gContextMenu.getLinkURL() : gContextMenu.linkURL();
      else if(document.popupNode)
      {
        if(document.popupNode.hasAttribute("href"))
          linkclicked = document.popupNode.href;
        else if(document.popupNode.parentNode && document.popupNode.parentNode.hasAttribute("href"))
          linkclicked = document.popupNode.parentNode.href;
      }  
      else
        linkclicked = TBrowseGlobal.getCurrentURL();
        
      if (linkclicked) 
        this.addTab(linkclicked);
    },
    addEventListener: function ()
    {
        this._deck.addEventListener.apply(null, arguments);
    }
};