//Our TB3 Tab Hook.

var ThunderBrowseTabType = {
    name: "thunderbrowse",
    perTabPanel: "vbox",
    lastBrowserId: 0,
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tbrowse."),
    get loadingTabString() {
      //So I don't have to add another string.
      return document.getElementById("bundle_messenger").getString("loadingTab");
    },

    modes: {
      thunderbrowse: {
        type: "thunderbrowse",
        maxTabs: 10000
      }
    },
    openTab: function onTabOpened(aTab, tabArg) {
      var url;
      if(tabArg["url"])
       url = tabArg["url"];
      else if(tabArg["contentPage"])
       url = tabArg["contentPage"];
      else
       url = TBrowseDev.getUserHomepage();
      var refer = tabArg["refer"];
      var secret = tabArg["secret"];
      var dataPost = tabArg["dataPost"];
      let splitr = document.createElement("splitter");
      splitr.setAttribute("disabled",true);
      splitr.setAttribute("class","tbrowser-splitter");
      splitr.setAttribute("orient", "vertical");
      splitr.setAttribute("persist","state");
      ThunderBrowseStartUp.passedUrl = url;
      aTab.panel.appendChild(splitr);
      var urlbar = ThunderBrowseStartUp.materializeBar(aTab.panel);
      aTab.urlbar = urlbar;
      aTab.panel.appendChild(splitr);
      //Create the browser
      let browser = document.createElement("browser");
      browser.setAttribute("type", "content-primary");
      browser.setAttribute("flex", "1");
      browser.setAttribute("autocompleteenabled", false);
      //Secret has to do with preloaded history.
      if(tabArg["histBack"])
      {
            aTab.urlbar.childNodes[0].disabled = false;
            browser.setAttribute("history-back", tabArg["histBack"]);
      }
      else if(secret != true)
            browser.setAttribute("history-back", TBrowseDev.getUserHomepage());  
      else
		browser.setAttribute("history-back","");
      if(tabArg["histFwd"])
      {
            aTab.urlbar.childNodes[2].disabled = false;
            browser.setAttribute("history-forward", tabArg["histFwd"]);
      }
      else
            browser.setAttribute("history-forward","");
      browser.setAttribute("disablehistory", true);
      browser.setAttribute("id", "ThunderBrowse-" + this.lastBrowserId);
      browser.setAttribute("onclick","return contentAreaClick(event);");
      browser.setAttribute("onmouseup","return ThunderBrowseHandler.clickEvent(event);");
      browser.setAttribute("onkeydown","return ThunderBrowseHandler.keyEvent(event);");
      browser.setAttribute("onmousedown","return ThunderBrowseHandler.watchMouseHolds(event);");
      browser.setAttribute("ondragover","nsDragAndDrop.dragOver(event,loadurlObserver)");
      browser.setAttribute("ondragdrop","nsDragAndDrop.drop(event,loadurlObserver)");
      browser.setAttribute("context","mailContext");
      browser.setAttribute("tbrowse",true);
      browser.tab = aTab.tabNode;

      browser.addEventListener('DOMTitleChanged', function(event) {
          if(typeof aTab.browser.contentTitle != 'undefined')
	    {
           aTab.title = aTab.label = aTab.browser.contentTitle;
           TBrowseGlobal.getTabHandler().setTabTitle(aTab);      
	    }
      }, true); 
 
      aTab.panel.appendChild(browser);
      aTab.linkedBrowser = aTab.browser = aTab.tabNode.browser = browser;
      //Makes the loading... text appear
      aTab.title = aTab.label = this.loadingTabString;
      aTab.tabNode.tbrowse = true;
		aTab.tabNode.isLoaded = false;
		aTab.tabNode.setAttribute("image", "chrome://global/skin/throbber/Throbber-small.gif");	
      TBrowserHooks.addGBrowserEl(browser);
      TBrowserHooks.addWatchLoads(browser, aTab.tabNode);
      TBrowsePermissions.imagesAllowed(browser);
      var customShortCutCheck = TBrowseCommands.checkForCustom(url);
      if(customShortCutCheck != false || (customShortCutCheck != false && customShortCutCheck == "nw"))
      {
         url = customShortCutCheck;
         if(customShortCutCheck == "nw")
           url = TBrowseDev.getUserHomepage();
      }
	  
	   browser.loadURIWithFlags(url, 0, (typeof refer === 'undefined') ? refer : null, "utf-8", ((dataPost != null) ? ThunderBrowseHandler.handlePostData(dataPost) : null));

      var findbar = document.createElement("findbar");
      findbar.setAttribute("browserid", "ThunderBrowse-" + this.lastBrowserId);
      aTab.panel.appendChild(findbar);

      aTab.findbar = aTab.panel.getElementsByTagName("findbar")[0];

      this.lastBrowserId++;
      TBrowseNavBar.tabSwitch();
      return aTab;
    },
    closeTab: function onTabClosed(tab) {
      TBrowserHooks.removeWatchLoads(tab.browser,tab.tabNode);
      tab.browser.loadURIWithFlags('about:blank');
    },
    saveTabState: function onSaveTabState(aTab) {
      aTab.panel.firstChild.setAttribute("type", "content-targetable");
    },
    showTab: function onShowTab(aTab) {
      aTab.panel.firstChild.setAttribute("type", "content-primary");
      TBrowseNavBar.tabSwitch();
      TBrowserCore.updateSecurityStatus();
      var browserfortab = aTab.browser;
      var currenturi = browserfortab.currentURI.spec;
      var protocolMailCheck = (currenturi.search(TBrowseGlobal.mailProtocols) == 0);
      if(protocolMailCheck == true)
      {
		  TBrowserCore.toggleContent(false);
		  gTBNavBar.setAttribute("collapsed",this.prefs.getBoolPref("hideme"));
      }
      else
      {
		  TBrowsePermissions.imagesAllowed(browserfortab); 
		  TBrowserCore.toggleContent(true);
		  gTBNavBar.setAttribute("collapsed",false);
      }
      if(currenturi)
       gTBURLBox.setAttribute("value",currenturi);
		 
      gTBBack.setAttribute("disabled",(browserfortab.getAttribute("history-back") == ""));	
      gTBFwd.setAttribute("disabled",(browserfortab.getAttribute("history-forward") == ""));
      TBHistory.reloadBackMenu();
      TBrowsExtras.checkIfURLsame();
		TBrowserCore.getWindowTitle();
		TBrowserCore.getFavicon(aTab.tabNode);
    },
	 onTitleChanged: function onTitleChanged(aTab) {
		if((/(^http(s)?)/i).test(aTab.browser.currentURI.scheme) == true)
		{
			if(typeof aTab.browser.contentTitle != 'undefined')
			 aTab.title = aTab.browser.contentTitle;
			 
			let favIconImage=aTab.browser.currentURI.scheme+'://'+aTab.browser.currentURI.host+'/favicon.ico';
			aTab.tabNode.setAttribute("image",favIconImage);
		}
    },
    persistTab: function onPersistTab(aTab) {
      if (aTab.browser.currentURI.spec == "about:blank")
        return null;

     if(this.prefs.getBoolPref("sessionHistory") == true && this.prefs.getBoolPref("enableSessionRestore") == true)
     {
      return {
        tabURI: aTab.browser.currentURI.spec,
        histBack: aTab.browser.getAttribute("history-back"),
        histFwd: aTab.browser.getAttribute("history-forward")
      };
     }
     else if(this.prefs.getBoolPref("enableSessionRestore") == true)
     {
       return {
        tabURI: aTab.browser.currentURI.spec
      };     
     }
     else
       return null;
      
    },
    restoreTab: function onRestoreTab(aTabmail, aPersistedState) {
     if(this.prefs.getBoolPref("sessionHistory") == true && this.prefs.getBoolPref("enableSessionRestore") == true)
     {
      aTabmail.openTab("thunderbrowse", { contentPage: aPersistedState.tabURI, histBack: aPersistedState.histBack, histFwd: aPersistedState.histFwd} );
     }
     else if(this.prefs.getBoolPref("enableSessionRestore") == true)
     {
      aTabmail.openTab("thunderbrowse", { contentPage: aPersistedState.tabURI} );     
     }
     else
      return null;
    },
    supportsCommand: function supportsCommand(aCommand, aTab) {
      switch (aCommand) {
        case "cmd_fullZoomReduce":
        case "cmd_fullZoomEnlarge":
        case "cmd_fullZoomReset":
        case "cmd_fullZoomToggle":
        case "cmd_find":
        case "cmd_findAgain":
        case "cmd_findPrevious":
        case "cmd_printSetup":
        case "cmd_print":
	case "cmd_reload":
          return true;
        default:
          return false;
      }
    },
    isCommandEnabled: function isCommandEnabled(aCommand, aTab) {
      switch (aCommand) {
        case "cmd_fullZoomReduce":
        case "cmd_fullZoomEnlarge":
        case "cmd_fullZoomReset":
        case "cmd_fullZoomToggle":
        case "cmd_find":
        case "cmd_findAgain":
        case "cmd_findPrevious":
        case "cmd_printSetup":
        case "cmd_print":
        case "cmd_reload":
          return true;
        default:
          return false;
      }
    },
    doCommand: function isCommandEnabled(aCommand, aTab) {
      switch (aCommand) {
        case "cmd_fullZoomReduce":
          ZoomManager.reduce();
          break;
        case "cmd_fullZoomEnlarge":
          ZoomManager.enlarge();
          break;
        case "cmd_fullZoomReset":
          ZoomManager.reset();
          break;
        case "cmd_fullZoomToggle":
          ZoomManager.toggleZoom();
          break;
	     case "cmd_printSetup":
          PrintUtils.showPageSetup();
          break;
        case "cmd_print":
          PrintUtils.print();
          break;
        case "cmd_find":
          aTab.findbar.onFindCommand();
          break;
        case "cmd_findAgain":
          aTab.findbar.onFindAgainCommand(false);
          break;
        case "cmd_findPrevious":
          aTab.findbar.onFindAgainCommand(true);
          break;
        case "cmd_reload":
          aTab.browser.reload();
          break;
      }
    },
    getBrowser: function getBrowser(aTab) {
      return aTab.browser;
    },
    getCurrentBrowser: function()
    {
     var tabmail = TBrowseGlobal.getTabHandler();
     if(tabmail.currentTabInfo.hasAttribute("tbrowse"))
       return tabmail.currentTabInfo.browser;                                            
     else
       return null;
    }
};
