/*
NAME: ThunderBrowse Buttons
AUTH: GameSpotting! Networks
DESC: Checks for commands for urls and reloads them
*/
var TBrowseCommands = {

	checkAbout: function(theloadthis)
	{
		if((/(^about:)/i).test(theloadthis) == true)
		{	
			if((TBrowseGlobal.aboutcmds).test(theloadthis))
				return true;
			else
				return false;
		}
		else
			return true;
	},
	checkForCommands: function(command)
	{
		var commandLoad = "";
		if((TBrowseGlobal.tbitcmds).test(command) || (TBrowseGlobal.aboutcmds).test(command) || (/(^google |^wiki |^yahoo |^flickr )/i).test(command))
		{
			commandLoad = command;
			if(command == "addons")
			{
				var addonshost;
				if(TBrowseGlobal.isSpice == true)
				 addonshost = "addons.spicebird.org";
				else
				 addonshost = "addons.mozilla.org";
         
				var theaddons = "https://"+addonshost+"/%LOCALE%/"+TBrowseGlobal.app+"/";
        if(TBrowseGlobal.isPostBox || TBrowseGlobal.isPostExpress)
          commandLoad = "http://www.postbox-inc.com/extensions";
        else
				  commandLoad = Components.classes["@mozilla.org/toolkit/URLFormatterService;1"].getService(Components.interfaces.nsIURLFormatter).formatURL(theaddons);
			}
			if(command == "home")
				commandLoad = TBrowseDev.getUserHomepage();		
			//about:				
			if(command == "about:commands" || command == "tbit:commands")
				commandLoad = "chrome://tbrowse/content/html/commands.xhtml";
			if(command == "about:kitchensink")
				commandLoad = "http://www.mozilla.org/docs/web-developer/samples/kitchensink.xml";
			//tbit:
			if(command == "tbit:about")
				commandLoad = "chrome://tbrowse/content/html/about.html";
			if(command == "tbit:license")
				commandLoad = "http://thunderbrowse.com/thunderblog/license/";
			if(command == "tbit:faq" || command == "tbit:FAQ")
				commandLoad = "http://thunderbrowse.com/thunderblog/faq/";
			if(command == "tbit:donate")
				commandLoad = "http://thunderbrowse.com/donate.php";
			if(command == "tbit:changelog")
				commandLoad = "chrome://tbrowse/content/changelog.txt";

			//search commands
			if((/(^google )/i).test(command))
			{
				var googlesearchme = command.split(/(^google )/i);
				var replacespace = encodeURIComponent(googlesearchme[2]);
				commandLoad = "http://www.google.com/search?client=thunderbrowse&q="+replacespace;
			}
			if((/(^yahoo )/i).test(command))
			{
				var yahoosearchme = command.split(/(^yahoo )/i);
				var replacespace = encodeURIComponent(yahoosearchme[2]);
				commandLoad = "http://search.yahoo.com/search?p="+replacespace;
			}
			if((/(^wiki )/i).test(command))
			{
				var wikisearchme = command.split(/(^wiki )/i);
				var replacespace = encodeURIComponent(wikisearchme[2]);
				commandLoad = "http://en.wikipedia.org/w/index.php?search="+replacespace;
			}
			if((/(^flickr )/i).test(command))
			{
				var flickrsearchme = command.split(/(^flickr )/i);
				var replacespace = flickrsearchme[2].replace(" ","+");
				var replacecomma = replacespace.replace(",","+OR+");
				commandLoad = "http://www.flickr.com/search/?q="+replacecomma+"&m=text";
			}
			//window openers
			if(command == "dl" || command == "about:downloads")
			{
				window.openDialog("chrome://mozapps/content/downloads/downloads.xul", "Current Downloads",'centerscreen');
				return "nw";  
			}
			if(command == "options" || command == "tbit:options")
			{
				window.openDialog("chrome://tbrowse/content/tbrowsesettings.xul",'','centerscreen');
				return "nw"; 
			}
		  return commandLoad;
		}
		else
		 return false;
	},
	checkForCustom: function(whattolookfor)
	{
		//checks for shortcuts. If no shortcuts, checks for commands
		var myshortcuts = thunderbrowseprefs.getCharPref("shortcutmodi").split(",");
		var myshorturl = thunderbrowseprefs.getCharPref("shortcuturl").split(",");
		var justcommand = whattolookfor.split(" ")[0];
		for(var i = 0; i < myshortcuts.length; i++)
		{
			if(justcommand == myshortcuts[i])
			{
				if(whattolookfor.split(" ")[1] != "" && typeof whattolookfor.split(" ")[1] != 'undefined')
				{
					var urltoload = myshorturl[i]+whattolookfor.split(" ")[1];
					return urltoload;					
				}
				else
					return myshorturl[i];		
			}
		}
		var checkThis = TBrowseCommands.checkForCommands(whattolookfor);
		return checkThis;
	},
	checkForUnknownProto: function(urltypedin)
	{
	  //It's actually a lot easier and faster to check how many : there are. If two, we don't know the protocol.
	  //This works because all the checks for other protocols have happened already
	  //And we are at the point of checking for anything that hasn't fit the previous rules
		var unknownProtocol = "http://"+urltypedin;
		if(urltypedin.split(":")[0] != "about" && urltypedin.split(":")[0] != "tbit" && unknownProtocol.split(":").length-1 >= 2)
		{
			//network.protocol-handler.warn-external-default needs to be off for this
			//network.protocol-handler.external-default also needs to be set to true
			TBrowserCore.toggleLaunch(true);
			var ioservice = Ccl["@mozilla.org/network/io-service;1"].getService(Cil.nsIIOService);
			var uriToOpen = ioservice.newURI(urltypedin, null, null);
			var extps = Ccl["@mozilla.org/uriloader/external-protocol-service;1"].getService(Cil.nsIExternalProtocolService);
			extps.loadURI(uriToOpen, null);
			return true;
		}
		else
		return false;
	}
};
