/*
NAME: ThunderBrowse Extras
AUTH: GameSpotting! Networks
DESC: Misc functions (TBrowsExtras) and developer stuff (TBrowseDev)
*/
var TBrowsExtras = {
checkIfURLsame : function()
{
	checkBrowser();
	if(gTBURLBox)
	{
			if((/(^http(s)?)/i).test(tbrowser.currentURI.scheme) == true && gTBURLBox.value != tbrowser.currentURI.spec)
      	 		gTBURLBox.value = tbrowser.currentURI.spec;
      	
      	if(gTBURLBox.value == "http://mail.google.com/mail/html/nocookies.html" || gTBURLBox.value == "https://mail.google.com/mail/html/nocookies.html")
      	ThunderBrowse.loadURL("https://mail.google.com/mail/?ui=html&zy=n", null, null, null, 3);
      }	
},
checkIfXPI : function(url)
{
	var fileCheck = url.lastIndexOf(".");
	if(url.length - fileCheck - 1 == 3)
	{
		var fileExt = url.substring(fileCheck,url.length).toLowerCase();
		if(fileExt == ".xpi")
			return true;
		else
			return false;
	}
	else
		return false;
},
newWelcomePage: function()
{
 //function to open the welcome page
 var tutorial = "chrome://tbrowse/content/html/start.xhtml";
 window.openDialog("chrome://tbrowse/content/tbwin.xul","_blank","scrollbars,resizable,chrome,dialog=no",tutorial);
}
};

//for developers
//see http://www.thunderbrowse.com/thunderblog/dev/
var TBrowseDev = {
appVer: null,
getCurrentURL: function()
{
  checkBrowser();
  return tbrowser.currentURI.spec;
},
getAppVersion: function()
{
	//does not work on TB1.0
	if(TBrowseDev.appVer == null)
	TBrowseDev.appVer = Ccl["@mozilla.org/xre/app-info;1"].getService(Cil.nsIXULAppInfo).version;
	return TBrowseDev.appVer;
}, 
getThunderBrowseVersion: function()
{
  return TBrowseGlobal.getVersion();
},
underTB3: function()
{
 return (TBrowseDev.compareAppVersions("1.5") == true && TBrowseDev.compareAppVersions("3.0a1") != true);
}, 
compareAppVersions: function(compwith)
{
 var versionChecker = Ccl["@mozilla.org/xpcom/version-comparator;1"]
			.getService(Cil.nsIVersionComparator);
 var curApp = TBrowseDev.getAppVersion();
 //running version number or later
  return (versionChecker.compare(curApp, compwith) >= 0);
},
getCurrentDocument : function()
{
 checkBrowser();
 return tbrowser.contentDocument.defaultView.document;
},
getUserHomepage : function()
{                                      
	var gethomepage;
	if(TBrowseGlobal.app == null)
		TBrowseGlobal.checkApplication();
	var prefserv = Ccl["@mozilla.org/preferences-service;1"].getService(Cil.nsIPrefService);
	if(TBrowseGlobal.isPostBox == false && TBrowseGlobal.isPostExpress == false)
	  gethomepage = prefserv.getBranch("mailnews.start_page.").getCharPref("url");
	else if(TBrowseGlobal.isPostBox == true && TBrowseGlobal.isPostExpress == false)
	  gethomepage = prefserv.getBranch("pb.start_page.").getCharPref("url");
	else
	  return "http://postbox-inc.com/start/default_express/index.php?app=PostboxExpress&buildid="+window.navigator.buildID;
	 return Ccl["@mozilla.org/toolkit/URLFormatterService;1"].getService(Cil.nsIURLFormatter).formatURL(gethomepage);
},
getHostName: function()
{
	checkBrowser();
	var thehost = tbrowser.currentURI.host;
	var hosturlparts = thehost.split(".");
	return hosturlparts[hosturlparts.length-2]+"."+hosturlparts[hosturlparts.length-1];
},
getHost: function()
{
	checkBrowser();
	return tbrowser.currentURI.host;
},
formatRefUri: function(url)
{
  	var ioservice = Ccl["@mozilla.org/network/io-service;1"].
        getService(Cil.nsIIOService);
	var refuri = ioservice.newURI(url, null, null);
	return refuri;
}
};
//end developers

//fixes messagepane not found bugs
//also fixes incorrect clearing
function ClearMessagePane()
{
  var url = TBrowseDev.getCurrentURL();
  if(typeof gHaveLoadedMessage == 'undefined')
	var gHaveLoadedMessage = false;
  var mailProtoChck = (url.search(TBrowseGlobal.mailProtocols) == 0);
  if(gHaveLoadedMessage || mailProtoChck == true)
  {
    var thehp = getUserHomepage();
    gHaveLoadedMessage = false;
    var paneFrame = document.getElementById("messagepane").contentWindow.top;   
    if (paneFrame.location.href != "about:blank" || paneFrame.location.href != thehp)
    {
		paneFrame.location.href = "about:blank";
        document.getElementById("messagepane").loadURIWithFlags(thehp,null,null);
    }
    // hide the message header view AND the message pane...
    HideMessageHeaderPane();
    gMessageNotificationBar.clearMsgNotifications();
    ClearPendingReadTimer();
  }
}

var loadurlObserver = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/html");
    return flavours;
  },

  onDragOver: function (event, flavour, session) {ThunderTabBrowser.selectedTab = event.target;},

  onDrop: function (event, dropdata, session) {
    var droptext = dropdata.data;
	 var testdata, splitter;
    if(droptext)
    {
	if((/http:/i).test(droptext) == true)
	{
		splitter = droptext.split(/http:/i)[1];
		testdata = "http:"+splitter.split("'")[0].split('"')[0];
	}
	else
	{
		splitter = droptext.split(/https:/i)[1];
		if(splitter)
			testdata = "https:"+splitter.split("'")[0].split('"')[0];
		else
			return 0;

	}
	ThunderBrowse.loadURL(testdata);
     }
  }
}
