/*
NAME: ThunderBrowse Manage User Data
AUTH: GameSpotting! Networks
DESC: This file manages the user's shortcuts and bookmarks. It's a private file only used for the manage window.
*/
var thunderbrowseprefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tbrowse.");

function loadAll()
{
 	add2Table(true);
	if(window.arguments && window.arguments[0] == "1")
		document.getElementById("whichManageTab").selectedIndex = 1;
}
/* Data Points */
var mybookmarks = thunderbrowseprefs.getCharPref("bookmarks").split("[");
var myshortcuts = thunderbrowseprefs.getCharPref("shortcutmodi").split(",");
var myshortcutsurl = thunderbrowseprefs.getCharPref("shortcuturl").split(",");

var myshorturl = myshortcutsurl;
var splitcuts = myshortcuts;
function enableDisBook()
{
	document.getElementById("deleteButton2").setAttribute("disabled",false);
}
function enableDis()
{
	document.getElementById("deleteButton").setAttribute("disabled",false);
}
function encodeData(barkString)
{
    //encodes strings if they have commas or [] in them
    if(barkString.split(",")[1] != null || barkString.split("[")[1] != null 
    || barkString.split("]")[1] != null || barkString.split("|")[1] != null)
    {
     var encoded = encodeURIComponent(barkString);
     var newstring = "ENC:"+encoded;
     return newstring;
    }
    else
     return barkString;
}
function decodeData(barkString)
{
     //encodes urls if they have commas in them (fixes comma bug)
    if(barkString.split("ENC:")[1] != null)
    {
     var removePrefix = barkString.split("ENC:")[1];
     return decodeURIComponent(removePrefix);
    }
    else
     return barkString; 
}
function add2Table(loadboth)
{
	if(document.getElementById("whichManageTab").selectedIndex == 0 || loadboth == true)
	{
	var shortCutTable = document.getElementById("shortCutTable");
	for(var i = 0; i < splitcuts.length; i++)
	{
		if(document.getElementById(i))
		{
			//do nothing
		}
		else
		{
			var item = document.createElement("treeitem");
			var treerow = document.createElement("treerow");
			var treecell1 = document.createElement("treecell");
			var treecell2 = document.createElement("treecell");
			item.setAttribute("id",[i]);
			item.setAttribute("editable",true);
			treecell1.setAttribute("label",myshortcuts[i]);
			treecell1.setAttribute("editable",true);
			treecell2.setAttribute("label",myshortcutsurl[i]);
			treecell2.setAttribute("editable",true);
			treecell2.setAttribute("tooltiptext",myshortcutsurl[i]);
			shortCutTable.appendChild(item);
			item.appendChild(treerow);
			treerow.appendChild(treecell1);
			treerow.appendChild(treecell2);
		}
	}
	}
	if(document.getElementById("whichManageTab").selectedIndex == 1 || loadboth == true)
	{

	var mybookmarks = thunderbrowseprefs.getCharPref("bookmarks").split("[");
	var bookTable = document.getElementById("bookTable");
	for(var i = 1; i < mybookmarks.length; i++)
	{
			var mysplitsociety = mybookmarks[i].split("|");
			var item = document.createElement("treeitem");
			var treerow = document.createElement("treerow");
			var treecell1 = document.createElement("treecell");
			var treecell2 = document.createElement("treecell");
			item.setAttribute("editable",true);
			var bookName = mysplitsociety[0].replace("[","");
			var bookURL = mysplitsociety[1].replace("]","");
			var decodeName = decodeData(bookName);
			var decodeUrl = decodeData(bookURL);
			treecell1.setAttribute("label",decodeName);
			treecell1.setAttribute("originalData",bookName);
			treecell1.setAttribute("editable",true);
			treecell2.setAttribute("label",decodeUrl);
			treecell2.setAttribute("editable",true);
			treecell2.setAttribute("originalData",bookURL);
			treecell2.setAttribute("tooltiptext",decodeUrl);
			bookTable.appendChild(item);
			item.appendChild(treerow);
			treerow.appendChild(treecell1);
			treerow.appendChild(treecell2);
	}
	}
}

function removeCustom()
{
	var tbstrings = document.getElementById("tburlstrings");
	if(document.getElementById("whichManageTab").selectedIndex == 1)
	{
		var theTree = document.getElementById("bookmarkTree");
		var shortcutTable = document.getElementById("bookTable");
		var number = theTree.currentIndex;		
		var which2remove = theTree.view.getCellText(theTree.currentIndex, theTree.columns.getColumnAt(0));
		var removebook = tbstrings.getString('deleteBookString');
		var shoulddelete = confirm(removebook+": "+which2remove+"?");
	}
	else
	{
		var theTree = document.getElementById("shortCutTree");
		var shortcutTable = document.getElementById("shortCutTable");
		var number = theTree.currentIndex;
		var which2remove = theTree.view.getCellText(theTree.currentIndex, theTree.columns.getColumnAt(0));
		var removecut = tbstrings.getString('deleteCutString');
		var shoulddelete = confirm(removecut+": "+which2remove+"?");
	}
	if(shoulddelete == true)
	{
		if(document.getElementById("whichManageTab").selectedIndex == 1)
		{
			var otherdata = theTree.view.getCellText(theTree.currentIndex,theTree.columns.getColumnAt(1));
			var replacer = "["+which2remove+"|"+otherdata+"]";
			var marks = thunderbrowseprefs.getCharPref("bookmarks");
			var replaced = marks.replace(replacer,"");
			thunderbrowseprefs.setCharPref("bookmarks",replaced);
		}
		else
		{
			var remove1 = myshortcuts.splice(number,1);
			var remove2 = myshorturl.splice(number,1);
			thunderbrowseprefs.setCharPref("shortcutmodi",myshortcuts);
			thunderbrowseprefs.setCharPref("shortcuturl",myshorturl);

		}
		var removalShort = shortcutTable.childNodes[number];
		shortcutTable.removeChild(removalShort);

	}
	else
	{
	    	dump("ThunderBrowse: Shortcut not deleted");
	}
	document.getElementById("deleteButton").setAttribute("disabled",true);
	document.getElementById("deleteButton2").setAttribute("disabled",true);
}
function cleanTable()
{

		var menuthing = document.getElementById("bookTable");
		for(var e = 0; e < menuthing.childNodes.length; ++e)
		{
			var removeme = document.getElementById("bookTable").childNodes[e];
			menuthing.removeChild(removeme);
		}
		if(menuthing.childNodes.length == 0)
			add2Table();
		else
			cleanTable();
}
function addCustom()
{
	var tbstrings = document.getElementById("tburlstrings");
	if(document.getElementById("whichManageTab").selectedIndex == 0)
	{
	var createshort = tbstrings.getString('createShortString');
	var createshort2 = tbstrings.getString('createShort2String');
	var destination = tbstrings.getString('destinationString');
	var shortpart1 = tbstrings.getString('shortcutString');
	var shortcut = prompt(createshort2,"",createshort);
	var urlto = prompt(shortpart1,"http://",destination);
	if(shortcut != null && urlto != null)
	{
		shortcut = shortcut.replace(" ","");
		var temp1 = new Array(myshortcuts);
		var myshortcuts2 = thunderbrowseprefs.getCharPref("shortcutmodi");
		if(myshortcuts2.match(shortcut) == null)
		{
		var temp2 = new Array(myshorturl);
		myshortcuts.push(shortcut);
		myshorturl.push(urlto);
		dump("ThunderBrowse: Creating shortcut");
		thunderbrowseprefs.setCharPref("shortcutmodi",temp1);
		thunderbrowseprefs.setCharPref("shortcuturl",temp2);
		}
	}
		add2Table();
	}
	else
	{
	var destination = tbstrings.getString('destinationString');
	var bookName = tbstrings.getString('bookNameString');
	var bookNameTitleString = tbstrings.getString('bookNameTitleString');
	var bookDestination = tbstrings.getString('bookDestinationString');
	var bookmark = prompt(bookName,"",bookNameTitleString);
	var urlto = prompt(bookDestination,"http://",destination);
	if(bookmark != null && urlto != null)
	{
		var newthing = "["+bookmark+"|"+urlto+"]";
		var oldbooks = thunderbrowseprefs.getCharPref("bookmarks");
		var newtoadd = oldbooks+newthing;
		thunderbrowseprefs.setCharPref("bookmarks",newtoadd);
	}
		cleanTable();
	}


}
function saveEditedStrings()
{
/* This is when I really wish TB2 supported JSON, it would have made my life easier */
var theTree = document.getElementById("shortCutTree");
var shortcutTable = document.getElementById("shortCutTable");
var thebookTree = document.getElementById("bookmarkTree");
var bookmarksTable = document.getElementById("bookTable");
var shortcutNames ="";
var shortcutUrls = "";
var tbBookmarks ="";
for(var i = 0; i < shortcutTable.childNodes.length; i++)
{
 if(i == 0)
 {
 shortcutNames = theTree.view.getCellText(i, theTree.columns.getColumnAt(0));
 shortcutUrls = theTree.view.getCellText(i, theTree.columns.getColumnAt(1));
 }
 else
 {
   shortcutNames += ","+theTree.view.getCellText(i, theTree.columns.getColumnAt(0));
   shortcutUrls += ","+theTree.view.getCellText(i, theTree.columns.getColumnAt(1)); 
 }
}
for(var i = 0; i < bookmarksTable.childNodes.length; i++)
{
var editedName = thebookTree.view.getCellText(i, thebookTree.columns.getColumnAt(0));
var editedURL = thebookTree.view.getCellText(i, thebookTree.columns.getColumnAt(1));
var encodedName = encodeData(editedName);
var encodedURL = encodeData(editedURL);
tbBookmarks += "["+encodedName+"|"+encodedURL+"]";
}
thunderbrowseprefs.setCharPref("shortcuturl",shortcutUrls);
thunderbrowseprefs.setCharPref("shortcutmodi",shortcutNames);
thunderbrowseprefs.setCharPref("bookmarks",tbBookmarks);
}
