/*
NAME: ThunderBrowse Tabs
AUTH: GameSpotting! Networks
DESC: Defines ThunderBrowse's tabs system. TB2Tabs is found in /tb2/tabs.js. TB3Tabs is found in /tb3/tabs.js
*/

var TBrowseTabChooser = {
	tabtype: thunderbrowseprefs.getIntPref("tabtype"),
	wintype: null,
	init: function()
	{
        this.wintype = document.documentElement.getAttribute("windowtype");
		var tabsys = null;
		if((this.tabtype == 1 || this.tabtype == 2) && this.wintype != "mail:messageWindow" && this.wintype != "tbrowse:win" && TBrowse3Tabs != null)
		{
			tabsys = this.tabtype;
			ThunderTabBrowser = TBrowse3Tabs;
			var tabmail = TBrowseGlobal.getTabHandler();
			if(tabmail)
			{
				tabmail.registerTabType(ThunderBrowseTabType);
				if(thunderbrowseprefs.getBoolPref("contentTabs") == true)
				{
					tabmail.tabTypes.webSearchTab = tabmail.tabTypes.contentTab = ThunderBrowseTabType;
					tabmail.tabModes.webSearchTab.tabType = tabmail.tabModes.contentTab.tabType = tabmail.tabTypes.contentTab; 
					tabmail.tabModes.webSearchTab.name = tabmail.tabModes.contentTab.name = "thunderbrowse";
					tabmail.tabModes.webSearchTab.type = tabmail.tabModes.contentTab.type = "thunderbrowse";
					tabmail.tabModes.webSearchTab.maxTabs = tabmail.tabModes.contentTab.maxTabs = 10000;
				}
			}
		}
		else if(TBrowse2Tabs)
		{
			tabsys = 0;
			ThunderTabBrowser = TBrowse2Tabs;
			ThunderTabBrowser._init(document.getElementById('thunderbrowse-tabs'),
			document.getElementById('thunderbrowse-deck'));
		}
		document.getElementById("messagepanebox").setAttribute("tabtype",tabsys);
		window.addEventListener("focus", function(e) { TBrowseTabChooser.checkTabType(); }, false);
		TBrowseNavBar.addWatcher();
	},
	reApp: function()
	{
	  try
	  {
		if((this.tabtype == 1 || this.tabtype == 2) && TBrowse3Tabs != null)
			ThunderTabBrowser = TBrowse3Tabs;
		else if(TBrowse2Tabs != null)
			ThunderTabBrowser = TBrowse2Tabs;
		}
		catch(e){ ThunderTabBrowser = TBrowse2Tabs; }
			
		TBrowseNavBar.tabSwitch();
	},
	checkTabType: function()
	{
		if(ThunderTabBrowser)
			this.reApp();
		else
			this.init();
	},
	gettabType: function()
	{
		if(document.getElementById("messagepanebox"))
			return document.getElementById("messagepanebox").getAttribute("tabtype");
	},
	get isThunderBrowseTab()
	{
		checkBrowser();
		var tabmail = TBrowseGlobal.getTabHandler();
		if((this.tabtype == 1 || this.tabtype == 0) && this.wintype != "tbrowse:win")
			return true;
		else if(this.wintype == "tbrowse:win")
			return false;
		else if(this.tabtype == 2 && tabmail && tabmail.currentTabInfo.mode.type == "thunderbrowse")
			return true;
		else
			return false;
	}
};

var tabCreatorObserver = {
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/html");
    return flavours;
  },

  onDragOver: function (event, flavour, session) {},

  onDrop: function (event, dropdata, session) {
    var droptext = dropdata.data;
	 var httpsRegExp = (/(^http(s)?:)/i);
    if(droptext)
    {
	   var protocolStr = null;
		if(httpsRegExp.test(droptext) == true)
		{
			protocolStr = ((/(^https:)/i).test(droptext)) ? "https:" : "http:";
			var splitter = droptext.split(httpsRegExp)[1];
			var newURL = protocolStr+splitter.split("'")[0].split('"')[0];
			ThunderTabBrowser.addTab(newURL);
		}
    }
  }
};
/* Tab Menu Commands */
var ThunderTabBrowserMenu = {

	reloadBrowserForTab : function()
	{
		var browserToRefresh = document.popupNode.browser;
		browserToRefresh.reload();
	},
	reloadBrowserForAllTabs : function()
	{
		var tabs = document.getElementById('thunderbrowse-tabs');
		for(var i = 0; i < tabs.childNodes.length; i++)
		{
			var tab = tabs.childNodes[i];
			var browserToRefresh = tab.browser;
			browserToRefresh.reload();
		}
	},
	removeAllPrior : function()
	{
		var tabs = document.getElementById('thunderbrowse-tabs');
		for(var i = 0; i < tabs.childNodes.length; i++)
		{
			if(tabs.childNodes[i])
			{
				if(tabs.childNodes[i].getAttribute("skipme"))
					tabs.childNodes[i].setAttribute("skipme",false);				
			}
		}
	},
	lockBrowser : function()
	{
		ThunderTabBrowserMenu.removeAllPrior();
		document.popupNode.setAttribute("skipme",true);
		var menuSelectedTab = document.popupNode;
		ThunderTabBrowser.selectedTab = document.popupNode;
		var tabs = document.getElementById('thunderbrowse-tabs');
		while(tabs.childNodes.length-1 != 1)
		{
			ThunderTabBrowserMenu.closeBrowserForAllOtherTabs();
		}
		if(tabs.childNodes.length == 1)
		{
			ThunderTabBrowser.selectedTab = document.getElementById("mail-tab");
			ThunderTabBrowser.selectedTab = menuSelectedTab;
		}
		else
		   ThunderTabBrowserMenu.closeBrowserForAllOtherTabs();
		
	},
	closeBrowserForAllOtherTabs : function()
	{
		var tabs = document.getElementById('thunderbrowse-tabs');
		for(var i = 0; i < tabs.childNodes.length; ++i)
		{
			if(tabs.childNodes[i])
			{
				if(tabs.childNodes[i].getAttribute("skipme") != true)
				{
					if(tabs.childNodes[i].selected != true)
    				 		ThunderTabBrowser.removeTab(tabs.childNodes[i],"1");                   
				}
			}
		}
		return false;
	}
};
